/*
 * Copyright 2016 - 2024 Gary Talent (gary@drinkingtea.net). All rights reserved.
 */

#pragma once

#include <imgui.h>

#include <turbine/context.hpp>

namespace studio::ig {

inline constexpr auto BtnSz = ImVec2{52, 22};

class IDStackItem {
	public:
		explicit IDStackItem(int id) noexcept;
		explicit IDStackItem(const char *id) noexcept;
		explicit IDStackItem(ox::CStringView id) noexcept;
		~IDStackItem() noexcept;
};

void centerNextWindow(turbine::Context &ctx) noexcept;

bool PushButton(ox::CStringView lbl, ImVec2 const&btnSz = BtnSz) noexcept;

enum class PopupResponse {
	None,
	OK,
	Cancel,
};

PopupResponse PopupControlsOkCancel(float popupWidth, bool &popupOpen);

[[nodiscard]]
bool BeginPopup(turbine::Context &ctx, ox::CStringView popupName, bool &show, ImVec2 const&sz = {285, 0});

/**
 *
 * @param lbl
 * @param list
 * @param selectedIdx
 * @return true if new value selected, false otherwise
 */
bool ComboBox(ox::CStringView lbl, ox::SpanView<ox::String> list, size_t &selectedIdx) noexcept;

}